from abc import ABC, abstractmethod
from typing import List, Optional, Dict, Any
from ..models.dsp.catalog import Dataset

class ICatalogService(ABC):

    @abstractmethod
    def create_dataset(self, dataset: Dataset) -> str:
        pass

    @abstractmethod
    def get_dataset(self, id: str) -> Dataset:
        pass

    @abstractmethod
    def list_datasets(self) -> List[Dataset]:
        pass

    # @abstractmethod
    # def update_dataset(self, dataset_id: str, updates: Dict[str, Any]) -> bool:
    #     pass

    @abstractmethod
    def delete_dataset(self, dataset_id: str) -> bool:
        pass
